---
title: AudioBufferSourceNode.loop
slug: Web/API/AudioBufferSourceNode/loop
tags:
  - API
  - Audio
  - AudioBufferSourceNode
  - Loop
  - Media
  - Property
  - Reference
  - Web Audio API
  - sound
---
<div>{{ APIRef("Web Audio API") }}</div>

<div>
<p>The <code>loop</code> property of the {{ domxref("AudioBufferSourceNode") }} interface is a Boolean indicating if the audio asset must be replayed when the end of the {{domxref("AudioBuffer")}} is reached.</p>
</div>

<p>The <code>loop</code> property's default value is <code>false</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>loopingEnabled</var> = <var>AudioBufferSourceNode</var>.loop;
<var>AudioBufferSourceNode</var>.loop = true | false;
</pre>

<h3 id="Value">Value</h3>

<p>A Boolean which is <code>true</code> if looping is enabled; otherwise, the value is <code>false</code>.</p>

<p>When looping is enabled, the sound begins playing at the time specified as the start point when {{domxref("AudioBufferSourceNode.start", "start()")}} is called. When the time specified by the {{domxref("AudioBufferSourceNode.loopEnd", "loopEnd")}} property is reached, playback continues at the time specified by {{domxref("AudioBufferSourceNode.loopStart", "loopStart")}}</p>

<h2 id="Example">Example</h2>

<p>In this example, the {{domxref("AudioContext.decodeAudioData")}} function is used to decode an audio track and put it into an {{domxref("AudioBufferSourceNode")}}. Buttons are provided to play and stop the audio playback, and a slider control is used to change the <code>playbackRate</code> property value on the fly. When the audio is played, it loops.</p>

<div class="note">
<p>You can <a class="external external-icon" href="https://mdn.github.io/webaudio-examples/decode-audio-data/">run the full example live</a> (or <a class="external external-icon" href="https://github.com/mdn/webaudio-examples/blob/master/decode-audio-data/index.html">view the source</a>.)</p>
</div>

<pre class="brush: js;highlight[17]">function getData() {
  source = audioCtx.createBufferSource();
  request = new XMLHttpRequest();

  request.open('GET', 'viper.ogg', true);

  request.responseType = 'arraybuffer';

  request.onload = function() {
    var audioData = request.response;

    audioCtx.decodeAudioData(audioData, function(buffer) {
        myBuffer = buffer;
        source.buffer = myBuffer;
        source.playbackRate.value = playbackControl.value;
        source.connect(audioCtx.destination);
        source.loop = true;
      },

      function(e){"Error with decoding audio data" + e.err});

  }

  request.send();
}

// wire up buttons to stop and play audio, and range slider control

play.onclick = function() {
  getData();
  source.start(0);
  play.setAttribute('disabled', 'disabled');
  playbackControl.removeAttribute('disabled');
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audiobuffersourcenode-loop', 'loop')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioBufferSourceNode.loop")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li>{{domxref("AudioBufferSourceNode")}}</li>
</ul>
